public class ListaBaralho {
	NoLista inicio;

	public ListaBaralho() 
	{
		this.inicio = null;
	} 
   
   
    public void insereOrdenado(int nome, int naipe)
	{
		NoLista novoNo = new NoLista(nome, naipe);
		
		NoLista ant = null; 
		NoLista p = this.inicio; 

		while (p != null && p.nome <= nome && p.naipe <= naipe) 
		{
			ant = p;
			p = p.proximo;
		}
		
		if (ant == null) 
		{ 
			novoNo.proximo = this.inicio;
			this.inicio = novoNo;
		} 
		
		else 
		{ 
			novoNo.proximo = ant.proximo;
			ant.proximo = novoNo;
		}   
	}

    // insere valor no comeo da lista
	public void inserirNoInicio(int nome, int naipe) 
	{
		if (this.inicio == null) 
		{
			// lista vazia, ento s  preciso criar o n
			this.inicio = new NoLista(nome, naipe);
		} 
		
		else 
		{
            // cria-se novo no e atualiza o NoLista inicio 
			NoLista novoNo = new NoLista(nome, naipe);
			
			novoNo.proximo = this.inicio;
			
			this.inicio = novoNo;
		}
			
	} 
   
    // insere valor no fim da lista	  
    public void inserirNoFim(int nome, int naipe) 
	{
		if (this.inicio == null) 
		{
			// lista vazia
			this.inicio = new NoLista(nome, naipe);
		} 
		
		else 
		{
			// procura pelo fim da lista
			NoLista atual = this.inicio;

			while (atual.proximo != null) 
			{
				atual = atual.proximo;
			}
			
			// insere o n no fim da lista
			atual.proximo = new NoLista(nome, naipe);
		}
			
	}  
	
	public void retira(int nome, int naipe) //Em qualquer posicao
	{
    
		NoLista ant = null; 
		NoLista p = this.inicio;     
		 
		while (p != null && (p.nome != nome || p.naipe != naipe)) {
		   ant = p;
		   p = p.proximo;
		}
		
		if (p != null)
		{
			if (ant == null) 
			{
			   this.inicio = p.proximo;
			}
	  
			else 
			{
			   ant.proximo = p.proximo;
			}
		}
	}
	
	public NoLista busca(int nome, int naipe)
	{
	    int i=0;
		
	    for (NoLista p = this.inicio; p!=null; p = p.proximo)
		{
			if(p.nome == nome && p.naipe == naipe)
			{
			   System.out.println("\n\nachou na posicao: " + i + "\n\n");
			   return p;
			}
			i++;
		}
		
		return null;
	}
	
	public void imprime()
	{
		for(NoLista q=this.inicio;q!=null; q=q.proximo)
		{
			System.out.println("Nome da carta: " + q.nome + "\n" +
					           "Naipe: " + q.naipe + "\n");
		}
	}

}
